package com.bergerkiller.bukkit.nolagg.base;

import java.util.LinkedHashMap;
import java.util.Map;

import org.bukkit.ChatColor;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.plugin.Plugin;

import com.bergerkiller.bukkit.common.PluginBase;
import com.bergerkiller.bukkit.common.permissions.NoPermissionException;

public abstract class NoLaggBase extends PluginBase {

	public NoLaggBase() {
		super();
	}

	public void updateDependency(Plugin plugin, String pluginname, boolean enabled) {
		if (!enabled) commands.remove(plugin);
	}

	private static Map<NoLaggBase, CommandHandler> commands = new LinkedHashMap<NoLaggBase, CommandHandler>();

	public final void register(CommandHandler cmd) {
		commands.put(this, cmd);
	}

	public void reload() {

	}

	public final boolean command(CommandSender sender, String cmd, String[] args) {
		try {
			if (args.length != 0) {
				if (args[0].equalsIgnoreCase("ver") || args[0].equalsIgnoreCase("version")) {
					for (NoLaggBase plugin : commands.keySet()) {
						sender.sendMessage(ChatColor.GREEN + plugin.getName() + " version " + plugin.getVersion());
					}
					return true;
				} else if (args[0].equalsIgnoreCase("reload")) {
					if (sender instanceof Player) {
						if (!sender.isOp() && !sender.hasPermission("nolagg.reload")) {
							throw new NoPermissionException();
						}
					}
					for (NoLaggBase plugin : commands.keySet()) {
						plugin.reload();
					}
					sender.sendMessage("Configuration of all NoLagg components reloaded!");
					return true;
				}
			}
			for (CommandHandler handler : commands.values()) {
				if (handler.handle(sender, args)) return true;
			}
			if (sender instanceof Player) {
				sender.sendMessage(ChatColor.RED + "Unknown sub-command!");
			} else {
				sender.sendMessage("Unknown sub-command!");
			}
		} catch (NoPermissionException ex) {
			if (sender instanceof Player) {
				sender.sendMessage(ChatColor.RED + "You don't have permission to use this!");
			} else {
				sender.sendMessage("This command is only for players!");
			}
		}
		return true;
	}

}
